diff -Nru WRFV3.5/phys/module_sf_clm.F WRFV3.5_MR/phys/module_sf_clm.F
--- WRFV3.5/phys/module_sf_clm.F	2013-04-17 17:12:47.000000000 +0200
+++ WRFV3.5_MR/phys/module_sf_clm.F	2014-12-17 11:53:55.877462524 +0100
@@ -32133,6 +32454,10 @@
        endif
     end do
 
+!cmrwrite
+   write(msg, *) 'cmr: in SoilWater: h20soi_liq = ',maxval(h2osoi_liq)
+   call CLMDebug(msg)
+
   end subroutine SoilWater
 
 !-----------------------------------------------------------------------
@@ -32247,7 +32572,7 @@
     real(r8) :: available_h2osoi_liq     !available soil liquid water in a layer
 !KO
 !-----------------------------------------------------------------------
-
+    character*254 :: msg  !cmr
     ! Assign local pointers to derived subtypes components (column-level)
 
     ctype          => clm3%g%l%c%itype
@@ -32539,6 +32864,9 @@
 
     end do
 
+!cmrwrite
+   write(msg, *) 'cmr: in Drainage: h20soi_liq = ',maxval(h2osoi_liq),'h20soi_ice = ', maxval(h2osoi_ice)
+   call CLMDebug(msg)
 
   end subroutine Drainage
 
@@ -35539,6 +35867,7 @@
     real(r8) :: snowcap_scl_fct            ! temporary factor used to correct for snow capping
     real(r8) :: fracl                      ! fraction of soil layer contributing to 10cm total soil water
 
+    character(254) :: msg !cmr
 !-----------------------------------------------------------------------
 
     ! Assign local pointers to derived subtypes components (gridcell-level)
@@ -35788,7 +36117,6 @@
        
        c = filter_nolakec(fc)
        l = clandunit(c)
-
        t_grnd(c) = t_soisno(c,snl(c)+1)
        if (ityplun(l) /= isturb) then
           t_soi_10cm(c) = t_soi_10cm(c)/0.1_r8
@@ -35816,6 +36144,14 @@
           c = filter_nolakec(fc)
           endwb(c) = endwb(c) + h2osoi_ice(c,j) + h2osoi_liq(c,j)
           h2osoi_vol(c,j) = h2osoi_liq(c,j)/(dz(c,j)*denh2o) + h2osoi_ice(c,j)/(dz(c,j)*denice)
+!cmrwrite
+   write(msg,*)'cmr: in Hydrology2: h2osoi_liq',maxval(h2osoi_liq),'h2osoi_ice',maxval(h2osoi_ice),'h2osoi_vol(c,j)',h2osoi_vol(c,j) 
+   CALL CLMDebug(msg) 
+! d01 2013-06-21_06:00:00  t_soi_10cm(c)=    283.1589335233167     
+! z(c,j) 6.2258571386337280E-002 dz(c,j)   4.5470034703612328E-002 
+!h2osoi_liq   1.0000000000000002E-002 h2osoi_ice    1.000000000000000
+!h2osoi_vol(c,j)   5.7101028202578765E-004
+!cmr end
        end do
     end do
 
@@ -35860,7 +36196,7 @@
        do fc = 1, num_hydrologyc
           c = filter_hydrologyc(fc)
           
-          if (h2osoi_liq(c,j) > 0._r8) then
+          if (h2ooi_liqoi_liq(c,j) > 0._r8) then
              vwc = h2osoi_liq(c,j)/(dz(c,j)*denh2o)
             
              ! the following limit set to catch very small values of 
@@ -36237,7 +36573,7 @@
 !
 ! !INTERFACE:
   subroutine CanopyFluxes(lbg, ubg, lbc, ubc, lbp, ubp, &
-                          num_nolakep, filter_nolakep)
+                          num_nolakep, filter_nolakep,atm_co2,valley_CO2pft2)
 !
 ! !DESCRIPTION:
 ! 1. Calculates the leaf temperature:
@@ -36271,7 +36607,8 @@
     use clmtype
     use clm_varpar         , only : nlevgrnd, nlevsno
     use clm_varcon         , only : sb, cpair, hvap, vkc, grav, denice, &
-                                    denh2o, tfrz, csoilc, tlsai_crit, alpha_aero
+!cmr: add lai                                    denh2o, tfrz, csoilc, tlsai_crit, alpha_aero
+                                    denh2o, tfrz, csoilc, tlsai_crit,alpha_aero,lai
     use QSatMod            , only : QSat
     use FrictionVelocityMod, only : FrictionVelocity, MoninObukIni
     use globals            , only : dtime
@@ -36283,6 +36620,8 @@
     integer, intent(in) :: lbp, ubp                    ! pft bounds
     integer, intent(in) :: num_nolakep                 ! number of column non-lake points in pft filter
     integer, intent(in) :: filter_nolakep(ubp-lbp+1)   ! pft filter for non-lake points
+    real,dimension(4), intent(in) :: atm_co2 !cmr
+    integer, intent(in) :: valley_CO2pft2              ! cmr second pft with forcing of pft 1
 !
 ! !CALLED FROM:
 ! subroutine Biogeophysics1 in module Biogeophysics1Mod
@@ -36303,6 +36642,7 @@
 !
 ! !LOCAL VARIABLES:
 !
+   CHARACTER*256 :: msg !cmr
 ! local pointers to implicit in variables
 !
    integer , pointer :: frac_veg_nosno(:) ! frac of veg not covered by snow (0 OR 1 now) [-]
@@ -36439,7 +36779,8 @@
    real(r8), parameter :: ria  = 0.5_r8    ! free parameter for stable formulation (currently = 0.5, "gamma" in Sakaguchi&Zeng,2008)
    real(r8) :: zldis(lbp:ubp)        ! reference height "minus" zero displacement height [m]
    real(r8) :: zeta                  ! dimensionless height used in Monin-Obukhov theory
-   real(r8) :: wc                    ! convective velocity [m/s]
+!cmr changed wc to wcv cause of double use of wc:   real(r8) :: wc                    ! convective velocity [m/s]
+   real(r8) :: wcv                    ! convective velocity [m/s]
    real(r8) :: dth(lbp:ubp)          ! diff of virtual temp. between ref. height and surface
    real(r8) :: dthv(lbp:ubp)         ! diff of vir. poten. temp. between ref. height and surface
    real(r8) :: dqh(lbp:ubp)          ! diff of humidity between ref. height and surface
@@ -36558,6 +36899,100 @@
    real(r8) :: dayl                  ! daylength (s)
    real(r8) :: temp                  ! temporary, for daylength calculation
    real(r8) :: dayl_factor(lbp:ubp)  ! scalar (0-1) for daylength effect on Vcmax
+   integer :: flop !cmr switch for stomata
+!cmr
+!   real(r8), pointer :: fco2(:)      ! net CO2 flux (umol CO2 /m**2 /s) [+ =to atm] 
+   real(r8), pointer :: reco(:)      ! respiration from soil and plants
+   real(r8), pointer :: reco_gpp(:)      ! respiration from soil and plants
+   real(r8), pointer :: reco_gppmn(:)      ! respiration from soil and plants
+   real(r8), pointer :: reco_gppmx(:)      ! respiration from soil and plants
+   real(r8), pointer :: wc(:)      ! rubisco limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wj(:)      ! light limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: we(:)      ! export limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wcsun(:)      ! rubisco limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wjsun(:)      ! light limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wesun(:)      ! export limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wcsha(:)      ! rubisco limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wjsha(:)      ! light limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: wesha(:)      ! export limited photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: psnsun2(:)    ! anthropogenic forcing photosynthesis (umol co2/m**2/s) 
+   real(r8), pointer :: psnsha2(:) 
+   real(r8), pointer :: psnsun3(:)    ! no feedback photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: psnsha3(:) 
+   real(r8), pointer :: psnsun4(:)    ! no feedback photosynthesis (umol co2/m**2/s)
+   real(r8), pointer :: psnsha4(:) 
+   real(r8), pointer :: fpsn_mn(:)      ! anthropogenic forcing photosynthesis
+   real(r8), pointer :: fpsn_mx(:)      ! no feedback photosynthesis 
+   real(r8), pointer :: fpsn_nf(:)      ! no feedback photosynthesis 
+   real(r8), pointer :: rs_mr(:)      ! stomatal resistance (s/m) for export
+   real(r8), pointer :: ci_mr(:)      ! intracellular CO2 (Pa) for export
+   real(r8), pointer :: rb_mr(:)      ! cmr
+   real(r8), pointer :: btran_mr(:)   ! cmr
+   real(r8), pointer :: apar_mr(:)    ! cmr
+   real(r8), pointer :: sla_mr(:)     ! cmr
+   real(r8), pointer :: vcmx_mr(:)    ! cmr
+   real(r8), pointer :: svpts_mr(:)   ! cmr saturation vapor pressure at t_veg (pa)
+   real(r8), pointer :: eah_mr(:)     ! cmr canopy air vapor pressure (pa) 
+   real(r8), pointer :: slasun(:)        ! specific leaf area for sunlit canopy, projected area basis (m^2/gC)
+   real(r8), pointer :: slasha(:)        ! specific leaf area for shaded canopy, projected area basis (m^2/gC)
+   real(r8), pointer :: vcmxsha(:)            ! shaded leaf Vcmax (umolCO2/m^2/s)
+   real(r8), pointer :: vcmxsun(:)            ! sunlit leaf Vcmax (umolCO2/m^2/s)
+   real(r8), pointer :: parsun(:)        ! average absorbed PAR for sunlit leaves (W/m**2)
+   real(r8), pointer :: parsha(:)        ! average absorbed PAR for shaded leaves (W/m**2)
+   real(r8),dimension(1:16) :: R0,al_lai,k2,E0,R0mn,al_laimn,k2mn,R0mx,al_laimx,k2mx,E0mn,E0mx
+   data(R0(i),i=1,16)/1.02,1.02,1.02,-0.47,-0.47,1.27,1.27,1.27,0.42,0.42,0.42,0.41,0.41,0.41,0.25,0.25/
+   data(R0mn(i),i=1,16)/0.6,0.6,0.6,-0.97,-0.97,0.77,0.77,0.77,0.03,0.03,0.03,-0.3,-0.3,-0.3,-0.41,-0.41/
+   data(R0mx(i),i=1,16)/1.44,1.44,1.44,0.03,0.03,1.77,1.77,1.77,0.81,0.81,0.81,1.12,1.12,1.12,0.91,0.91/
+   data(al_lai(i),i=1,16)/0.42,0.42,0.42,0.82,0.82,0.34,0.34,0.34,0.57,0.57,0.57,1.14,1.14,1.14,0.40,0.40/
+   data(al_laimn(i),i=1,16)/0.34,0.34,0.34,0.69,0.69,0.24,0.24,0.24,0.40,0.40,0.40,0.81,0.81,0.81,0.29,0.29/
+   data(al_laimx(i),i=1,16)/0.50,0.50,0.50,0.95,0.95,0.44,0.44,0.44,0.74,0.74,0.74,1.47,1.47,1.47,0.51,0.51/
+   data(k2(i),i=1,16)/0.478,0.478,0.478,0.602,0.602,0.247,0.247,0.247,0.354,0.354,0.354,0.578,0.578,0.578,0.244,0.244/
+   data(k2mn(i),i=1,16)/0.465,0.465,0.465,0.658,0.658,0.238,0.238,0.238,0.333,0.333,0.333,0.516,0.516,0.516,0.228,0.228/
+   data(k2mx(i),i=1,16)/0.491,0.491,0.491,0.646,0.646,0.256,0.256,0.256,0.375,0.375,0.375,0.640,0.640,0.640,0.260,0.260/
+   data(E0(i),i=1,16)/124.833,124.833,124.833,52.753,52.753,87.655,87.655,87.655,156.746,156.746,156.746,101.181,101.181,101.181,129.498,129.498/
+   data(E0mn(i),i=1,16)/120.177,120.177,120.177,48.402,48.402,83.25,83.25,83.25,148.524,148.524,148.524,94.819,94.819,94.819,123.88,123.88/
+   data(E0mx(i),i=1,16)/129.489,129.489,129.489,57.104,57.104,92.06,92.06,92.06,164.968,164.968,164.968,107.543,107.543,107.543,135.116,135.116/
+
+!   fco2      => clm3%g%l%c%p%pcf%fco2
+   reco      => clm3%g%l%c%p%pcf%reco
+   reco_gpp      => clm3%g%l%c%p%pcf%reco_gpp
+   reco_gppmn      => clm3%g%l%c%p%pcf%reco_gppmn
+   reco_gppmx      => clm3%g%l%c%p%pcf%reco_gppmx
+   wj    => clm3%g%l%c%p%pcf%wj
+   wc    => clm3%g%l%c%p%pcf%wc
+   we    => clm3%g%l%c%p%pcf%we
+   wjsun    => clm3%g%l%c%p%pcf%wjsun
+   wcsun    => clm3%g%l%c%p%pcf%wcsun
+   wesun    => clm3%g%l%c%p%pcf%wesun
+   wjsha    => clm3%g%l%c%p%pcf%wjsha
+   wcsha    => clm3%g%l%c%p%pcf%wcsha
+   wesha    => clm3%g%l%c%p%pcf%wesha
+   psnsun2  => clm3%g%l%c%p%pcf%psnsun2
+   psnsun3  => clm3%g%l%c%p%pcf%psnsun3
+   psnsun4  => clm3%g%l%c%p%pcf%psnsun4
+   psnsha2  => clm3%g%l%c%p%pcf%psnsha2
+   psnsha3  => clm3%g%l%c%p%pcf%psnsha3
+   psnsha4  => clm3%g%l%c%p%pcf%psnsha4
+   fpsn_mn  => clm3%g%l%c%p%pcf%fpsn_mn
+   fpsn_mx  => clm3%g%l%c%p%pcf%fpsn_mx
+   fpsn_nf  => clm3%g%l%c%p%pcf%fpsn_nf
+   ci_mr  => clm3%g%l%c%p%pps%ci_mr
+   rs_mr  => clm3%g%l%c%p%pps%rs_mr
+   rb_mr  => clm3%g%l%c%p%pps%rb_mr
+   btran_mr  => clm3%g%l%c%p%pps%btran_mr
+   apar_mr  => clm3%g%l%c%p%pps%apar_mr
+   sla_mr  => clm3%g%l%c%p%pps%sla_mr
+   vcmx_mr  => clm3%g%l%c%p%pps%vcmx_mr
+   svpts_mr  => clm3%g%l%c%p%pps%svpts_mr
+   eah_mr  => clm3%g%l%c%p%pps%eah_mr
+   slasun  => clm3%g%l%c%p%pps%slasun
+   slasha  => clm3%g%l%c%p%pps%slasha
+   vcmxsha  => clm3%g%l%c%p%pps%vcmxsha
+   vcmxsun  => clm3%g%l%c%p%pps%vcmxsun
+   parsun  => clm3%g%l%c%p%pef%parsun
+   parsha  => clm3%g%l%c%p%pef%parsha
+
+!cmr end
 !------------------------------------------------------------------------------
 
    ! Assign local pointers to derived type members (gridcell-level)
@@ -36677,7 +37112,6 @@
    smpsc          => pftcon%smpsc
 
 
-
    ! Filter pfts where frac_veg_nosno is non-zero
 
    fn = 0
@@ -36803,7 +37237,13 @@
 
       ! Determine atmospheric co2 and o2
 
-      co2(p) = forc_pco2(g)
+!cmr      co2(p) = forc_pco2(g)
+! make a namelist controlled co2 feedback
+!      IF ( co2_feedback == 1) THEN
+      co2(p) = atm_co2(1)*forc_pbot(g) 
+!      ENDIF
+
+!cmr end
       o2(p)  = forc_po2(g)
       
 #if (defined C13)
@@ -36942,9 +37382,24 @@
       end do
 
       ! 4/25/05, PET: Now calling the sun/shade version of Stomata by default
-      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, phase='sun')
-      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, phase='sha')
-
+      flop = 1 !cmr: FPSN with feedback
+      co2(p) = atm_co2(flop)*forc_pbot(g) 
+      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase='sun')
+      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase='sha')
+
+      flop = 2 ! minimal NEE
+      co2(p) = atm_co2(flop)*forc_pbot(g)
+      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase='sun')
+      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase='sha')
+      flop = 3 !cmr: maximal NEE
+      co2(p) = atm_co2(flop)*forc_pbot(g)
+      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase='sun')
+      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase='sha')
+      
+      flop = 4 !cmr: FPSN without feedback
+      co2(p) = atm_co2(flop)*forc_pbot(g)
+      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase='sun')
+      call Stomata (fn, filterp, lbp, ubp, svpts, eah, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase='sha')
 !dir$ concurrent
 !cdir nodep
       do f = 1, fn
@@ -37113,8 +37568,8 @@
             um(p) = max(ur(p),0.1_r8)
          else                     !unstable
             zeta = max(-100._r8,min(zeta,-0.01_r8))
-            wc = beta*(-grav*ustar(p)*thvstar*zii/thv(c))**0.333_r8
-            um(p) = sqrt(ur(p)*ur(p)+wc*wc)
+            wcv = beta*(-grav*ustar(p)*thvstar*zii/thv(c))**0.333_r8 !cmr:  wc -> wcv
+            um(p) = sqrt(ur(p)*ur(p)+wcv*wcv) !cmr:  wc -> wcv
          end if
          obu(p) = zldis(p)/zeta
 
@@ -37211,7 +37666,56 @@
       ! total photosynthesis
 
       fpsn(p) = psnsun(p)*laisun(p) + psnsha(p)*laisha(p)
-      
+!cmr: do antro & single of photosynthesis:
+      fpsn_mx(p) = psnsun2(p)*laisun(p) + psnsha2(p)*laisha(p) + &
+              0.3*(psnsun2(p)*laisun(p) + psnsha2(p)*laisha(p))
+      fpsn_mn(p) = psnsun3(p)*laisun(p) + psnsha3(p)*laisha(p) - & 
+              0.3*(psnsun3(p)*laisun(p) + psnsha3(p)*laisha(p))
+      fpsn_nf(p) = psnsun4(p)*laisun(p) + psnsha4(p)*laisha(p)
+      wj(p) = wjsun(p)*laisun(p) + wjsha(p)*laisha(p)
+      we(p) = wesun(p)*laisun(p) + wesha(p)*laisha(p)
+      wc(p) = wcsun(p)*laisun(p) + wcsha(p)*laisha(p)
+      ci_mr(p) = cisun(p)+cisha(p)
+      rs_mr(p) = rssun(p)+rssha(p) 
+      rb_mr(p) = rb(p)
+      btran_mr(p) = btran(p) 
+      apar_mr(p) = parsun(p)+parsha(p)
+      sla_mr(p) = slasun(p)+slasha(p)
+      vcmx_mr(p) = vcmxsun(p)+vcmxsha(p) 
+
+!cmr get saturation vapor pressure svpts_mr and vapor pressure of canopy air eah_mr:
+      svpts_mr(p) = el(p)                         ! pa
+      eah_mr(p) = forc_pbot(g) * qaf(p) / 0.622_r8   ! pa
+
+!cmr do respiration
+! R_ecosystem = R_soil + R_plant
+! RsTref = 3.23
+! RpTref = 0.58
+! Es = 78844
+! Ep = 69571
+! Tp = t_veg !leaf temperature in Kelvin
+! Ts = t_soisno(c,3)  ! soil temperature (Kelvin) (c,3) is for top 30 cm 
+! R = 8.314 ! universal gas constant [J mol^-1 K^-1]
+! Tref = 283.16 !reference Temperature [K]
+! L = laisun+laisha  ! sunlit and shaded projected leaf area index 
+! reco = RsTref*exp(Es/(R*Tref)*(1-Tref/Ts)) + L*RpTref*exp(Ep/(R*Tref)*(1-Tref/Tp))  
+      reco(p) = 3.23*exp(78844/(8.314*283.16)*(1-283.16/t_soisno(c,3)))+ &
+                (laisun(p)+laisha(p))*0.58*exp(69571/(8.314*283.16)*(1-283.16/t_veg(p))) 
+! R_eco according to migliavacca linGPP:
+reco_gpp(p)=(R0(ivt(p))+al_lai(ivt(p))*maxval(lai(ivt(p),:))+k2(ivt(p))*fpsn(p))*exp(E0(ivt(p))*(1/(288.15-227.13)-1/(taf(p)-227.13))) 
+reco_gppmn(p)=(R0mn(ivt(p))+al_laimn(ivt(p))*maxval(lai(ivt(p),:))+k2mn(ivt(p))*fpsn(p))*exp(E0mn(ivt(p))*(1/(288.15-227.13)-1/(taf(p)-227.13))) 
+reco_gppmx(p)=(R0mx(ivt(p))+al_laimx(ivt(p))*maxval(lai(ivt(p),:))+k2mx(ivt(p))*fpsn(p))*exp(E0mx(ivt(p))*(1/(288.15-227.13)-1/(taf(p)-227.13))) 
+
+! Net ecosystem exchange:
+!      fco2(p) = reco(p) - fpsn(p)
+! Check out the Values: 
+!   write(msg,*)'shape(t_soisno)',shape(t_soisno),'t_soisno(c,1)=',t_soisno(c,1),'t_soisno(c,2)=',t_soisno(c,2),'t_soisno(c,3)=',t_soisno(c,3), &
+!               't_veg(p)=',t_veg(p)
+!   write(msg,*) 'p=',p,'ivt(p)=',ivt(p),'maxval(lai(ivt(p),:))',maxval(lai(ivt(p),:)),'reco_gpp(p)=',reco_gpp(p),'taf(p)',taf(p)
+!   CALL wrf_debug(0,msg)
+!cmr end
+
+
 #if (defined CN) && (defined C13)
       ! 4/14/05: PET
       ! Adding isotope code
@@ -37249,7 +37753,8 @@
 ! !IROUTINE: Stomata
 !
 ! !INTERFACE:
-   subroutine Stomata (fn, filterp, lbp, ubp, ei, ea, o2, co2, rb, dayl_factor, phase)
+!cmr   subroutine Stomata (fn, filterp, lbp, ubp, ei, ea, o2, co2, rb, dayl_factor, phase)
+   subroutine Stomata (fn, filterp, lbp, ubp, ei, ea, o2, co2, rb, dayl_factor, flop, valley_CO2pft2, phase)
 !
 ! !DESCRIPTION: 
 ! Leaf stomatal resistance and leaf photosynthesis. Modifications for CN code.
@@ -37285,6 +37790,8 @@
      real(r8), intent(inout) :: rb(lbp:ubp)        ! boundary layer resistance (s/m)
      real(r8), intent(in)    :: dayl_factor(lbp:ubp) ! scalar (0-1) for daylength
      character(len=*), intent(in) :: phase         ! 'sun' or 'sha'
+     integer , intent(in)    :: flop               ! cmr: 1,2 and 3 for CO2 with feedback, anthropogenic source and without feedback 
+     integer, intent(in) :: valley_CO2pft2              ! cmr second pft with forcing of pft 1
 !
 ! !CALLED FROM:
 ! subroutine CanopyFluxes in this module
@@ -37320,6 +37827,12 @@
      real(r8), pointer :: alphapsn(:)    ! 13C fractionation factor for PSN ()
 #endif
 
+!cmr add variables for output
+     real(r8), pointer :: wc(:)      ! rubisco limited photosynthesis (umol co2/m**2/s)
+     real(r8), pointer :: wj(:)      ! light limited photosynthesis (umol co2/m**2/s)
+     real(r8), pointer :: we(:)      ! export limited photosynthesis (umol co2/m**2/s)
+!cmr
+
 !
 ! local pointers to implicit out variables
 !
@@ -37348,9 +37861,9 @@
      real(r8) :: q       ! intermediate calculations for rs
      real(r8) :: r1,r2   ! roots for rs
      real(r8) :: ppf     ! absorb photosynthetic photon flux (umol photons/m**2/s)
-     real(r8) :: wc      ! rubisco limited photosynthesis (umol co2/m**2/s)
-     real(r8) :: wj      ! light limited photosynthesis (umol co2/m**2/s)
-     real(r8) :: we      ! export limited photosynthesis (umol co2/m**2/s)
+!cmr     real(r8) :: wc      ! rubisco limited photosynthesis (umol co2/m**2/s)
+!cmr     real(r8) :: wj      ! light limited photosynthesis (umol co2/m**2/s)
+!cmr     real(r8) :: we      ! export limited photosynthesis (umol co2/m**2/s)
      real(r8) :: cp      ! co2 compensation point (pa)
      real(r8) :: awc     ! intermediate calcuation for wc
      real(r8) :: j       ! electron transport (umol co2/m**2/s)
@@ -37369,7 +37882,8 @@
      real(r8) :: q10act  ! (DIM) Q_10 for Rubisco activity
      real(r8) :: fnr     ! (gRubisco/gN in Rubisco)
 !------------------------------------------------------------------------------
-
+     character*256 :: msg !cmr
+     integer  :: temp_ivt !cmr temporary integer
      ! Set statement functions
 
      f1(ab,bc) = ab**((bc-25._r8)/10._r8)
@@ -37385,7 +37899,7 @@
      if (phase == 'sun') then
         apar   => clm3%g%l%c%p%pef%parsun
         rs     => clm3%g%l%c%p%pps%rssun
-        psn    => clm3%g%l%c%p%pcf%psnsun
+!cmr        psn    => clm3%g%l%c%p%pcf%psnsun
         ci     => clm3%g%l%c%p%pps%cisun
 #if (defined C13)
         alphapsn  => clm3%g%l%c%p%pps%alphapsnsun
@@ -37393,10 +37907,25 @@
         sla    => clm3%g%l%c%p%pps%slasun
         lnc    => clm3%g%l%c%p%pps%lncsun   
         vcmx   => clm3%g%l%c%p%pps%vcmxsun   
+!cmr 
+        wj    => clm3%g%l%c%p%pcf%wjsun
+        wc    => clm3%g%l%c%p%pcf%wcsun
+        we    => clm3%g%l%c%p%pcf%wesun
+        if (flop .eq. 1) then
+          psn    => clm3%g%l%c%p%pcf%psnsun
+        else if (flop .eq. 2) then
+          psn    => clm3%g%l%c%p%pcf%psnsun2
+        else if (flop .eq. 3) then
+          psn    => clm3%g%l%c%p%pcf%psnsun3
+        else if (flop .eq. 4) then
+          psn    => clm3%g%l%c%p%pcf%psnsun4
+        end if
+
+!cmr end
      else if (phase == 'sha') then
         apar   => clm3%g%l%c%p%pef%parsha
         rs     => clm3%g%l%c%p%pps%rssha
-        psn    => clm3%g%l%c%p%pcf%psnsha
+!cmr         psn    => clm3%g%l%c%p%pcf%psnsha
         ci     => clm3%g%l%c%p%pps%cisha
         sla    => clm3%g%l%c%p%pps%slasha   
 #if (defined C13)
@@ -37404,8 +37933,23 @@
 #endif
         lnc    => clm3%g%l%c%p%pps%lncsha   
         vcmx   => clm3%g%l%c%p%pps%vcmxsha
+!cmr 
+        wj    => clm3%g%l%c%p%pcf%wjsha
+        wc    => clm3%g%l%c%p%pcf%wcsha
+        we    => clm3%g%l%c%p%pcf%wesha
+        if (flop .eq. 1) then
+          psn    => clm3%g%l%c%p%pcf%psnsha
+        else if (flop .eq. 2) then
+          psn    => clm3%g%l%c%p%pcf%psnsha2
+        else if (flop .eq. 3) then
+          psn    => clm3%g%l%c%p%pcf%psnsha3
+        else if (flop .eq. 4) then
+          psn    => clm3%g%l%c%p%pcf%psnsha4
+        end if
+!cmr end
      end if
 
+
      ! Assign local pointers to derived type members (gridcell-level)
 
      forc_pbot => clm_a2l%forc_pbot
@@ -37444,6 +37988,7 @@
 
      act25 = act25 * 1000.0_r8 / 60.0_r8
 
+
 !dir$ concurrent
 !cdir nodep
      do f = 1, fn
@@ -37451,7 +37996,18 @@
         c = pcolumn(p)
         g = pgridcell(p)
 
-        ! Initialize rs=rsmax and psn=0 because calculations are performed only
+!cmr set swappped ivt for flop = 2 to get psn of other parameterization with
+!similar temperatures as base ivt:
+!        if (flop .eq. 2) then
+!          temp_ivt = ivt(p)
+!          ivt(p) = valley_CO2pft2
+!        endif
+
+!    write(msg,*) 'p = ',p,' ivt(p) = ',ivt(p)
+!    CALL wrf_debug(0,msg)
+!cmr end
+
+       ! Initialize rs=rsmax and psn=0 because calculations are performed only
         ! when apar > 0, in which case rs <= rsmax and psn >= 0
         ! Set constants
 
@@ -37466,7 +38022,9 @@
            alphapsn(p) = 1._r8
 #endif
         else                             ! day time
+          
            tc = tl(p) - SHR_CONST_TKFRZ
+
            ppf = 4.6_r8 * apar(p)                  
            j = ppf * qe25(ivt(p))
            kc = kc25 * f1(akc,tc)       
@@ -37491,7 +38049,7 @@
 #if (defined CN)
            vcmx(p) = lnc(p) * flnr(ivt(p)) * fnr * act / f2(tc) * btran(p) * dayl_factor(p)
 #else
-           vcmx(p) = lnc(p) * flnr(ivt(p)) * fnr * act / f2(tc) * btran(p) * dayl_factor(p) * fnitr(ivt(p))
+           vcmx(p) = lnc(p) * flnr(ivt(p)) * fnr * act / f2(tc) * btran(p) *dayl_factor(p) * fnitr(ivt(p))
 #endif
            
            ! First guess ci
@@ -37513,10 +38071,10 @@
            !
            ! ITER = 1
            !
-           wj = max(ci(p)-cp,0._r8)*j/(ci(p)+2._r8*cp)*c3psn(ivt(p)) + j*(1._r8-c3psn(ivt(p)))
-           wc = max(ci(p)-cp,0._r8)*vcmx(p)/(ci(p)+awc)*c3psn(ivt(p)) + vcmx(p)*(1._r8-c3psn(ivt(p)))
-           we = 0.5_r8*vcmx(p)*c3psn(ivt(p)) + 4000._r8*vcmx(p)*ci(p)/forc_pbot(g)*(1._r8-c3psn(ivt(p))) 
-           psn(p) = min(wj,wc,we) 
+           wj(p) = max(ci(p)-cp,0._r8)*j/(ci(p)+2._r8*cp)*c3psn(ivt(p)) + j*(1._r8-c3psn(ivt(p)))
+           wc(p) = max(ci(p)-cp,0._r8)*vcmx(p)/(ci(p)+awc)*c3psn(ivt(p)) + vcmx(p)*(1._r8-c3psn(ivt(p)))
+           we(p) = 0.5_r8*vcmx(p)*c3psn(ivt(p)) + 4000._r8*vcmx(p)*ci(p)/forc_pbot(g)*(1._r8-c3psn(ivt(p))) 
+           psn(p) = min(wj(p),wc(p),we(p)) 
            cs = max( co2(p)-1.37_r8*rb(p)*forc_pbot(g)*psn(p), mpe )
            atmp = mp(ivt(p))*psn(p)*forc_pbot(g)*cea / (cs*ei(p)) + bp
            btmp = ( mp(ivt(p))*psn(p)*forc_pbot(g)/cs + bp ) * rb(p) - 1._r8
@@ -37533,10 +38091,10 @@
            !
            ! ITER = 2
            !
-           wj = max(ci(p)-cp,0._r8)*j/(ci(p)+2._r8*cp)*c3psn(ivt(p)) + j*(1._r8-c3psn(ivt(p)))
-           wc = max(ci(p)-cp,0._r8)*vcmx(p)/(ci(p)+awc)*c3psn(ivt(p)) + vcmx(p)*(1._r8-c3psn(ivt(p)))
-           we = 0.5_r8*vcmx(p)*c3psn(ivt(p)) + 4000._r8*vcmx(p)*ci(p)/forc_pbot(g)*(1._r8-c3psn(ivt(p))) 
-           psn(p) = min(wj,wc,we) 
+           wj(p) = max(ci(p)-cp,0._r8)*j/(ci(p)+2._r8*cp)*c3psn(ivt(p)) + j*(1._r8-c3psn(ivt(p)))
+           wc(p) = max(ci(p)-cp,0._r8)*vcmx(p)/(ci(p)+awc)*c3psn(ivt(p)) + vcmx(p)*(1._r8-c3psn(ivt(p)))
+           we(p) = 0.5_r8*vcmx(p)*c3psn(ivt(p)) + 4000._r8*vcmx(p)*ci(p)/forc_pbot(g)*(1._r8-c3psn(ivt(p))) 
+           psn(p) = min(wj(p),wc(p),we(p)) 
            cs = max( co2(p)-1.37_r8*rb(p)*forc_pbot(g)*psn(p), mpe )
            atmp = mp(ivt(p))*psn(p)*forc_pbot(g)*cea / (cs*ei(p)) + bp
            btmp = ( mp(ivt(p))*psn(p)*forc_pbot(g)/cs + bp ) * rb(p) - 1._r8
@@ -37553,10 +38111,10 @@
            !
            ! ITER = 3
            !
-           wj = max(ci(p)-cp,0._r8)*j/(ci(p)+2._r8*cp)*c3psn(ivt(p)) + j*(1._r8-c3psn(ivt(p)))
-           wc = max(ci(p)-cp,0._r8)*vcmx(p)/(ci(p)+awc)*c3psn(ivt(p)) + vcmx(p)*(1._r8-c3psn(ivt(p)))
-           we = 0.5_r8*vcmx(p)*c3psn(ivt(p)) + 4000._r8*vcmx(p)*ci(p)/forc_pbot(g)*(1._r8-c3psn(ivt(p))) 
-           psn(p) = min(wj,wc,we) 
+           wj(p) = max(ci(p)-cp,0._r8)*j/(ci(p)+2._r8*cp)*c3psn(ivt(p)) + j*(1._r8-c3psn(ivt(p)))
+           wc(p) = max(ci(p)-cp,0._r8)*vcmx(p)/(ci(p)+awc)*c3psn(ivt(p)) + vcmx(p)*(1._r8-c3psn(ivt(p)))
+           we(p) = 0.5_r8*vcmx(p)*c3psn(ivt(p)) + 4000._r8*vcmx(p)*ci(p)/forc_pbot(g)*(1._r8-c3psn(ivt(p))) 
+           psn(p) = min(wj(p),wc(p),we(p)) 
            cs = max( co2(p)-1.37_r8*rb(p)*forc_pbot(g)*psn(p), mpe )
            atmp = mp(ivt(p))*psn(p)*forc_pbot(g)*cea / (cs*ei(p)) + bp
            btmp = ( mp(ivt(p))*psn(p)*forc_pbot(g)/cs + bp ) * rb(p) - 1._r8
@@ -37573,10 +38131,10 @@
 !NEC NEC NEC
 #else
            do iter = 1, niter
-              wj = max(ci(p)-cp,0._r8)*j/(ci(p)+2._r8*cp)*c3psn(ivt(p)) + j*(1._r8-c3psn(ivt(p)))
-              wc = max(ci(p)-cp,0._r8)*vcmx(p)/(ci(p)+awc)*c3psn(ivt(p)) + vcmx(p)*(1._r8-c3psn(ivt(p)))
-              we = 0.5_r8*vcmx(p)*c3psn(ivt(p)) + 4000._r8*vcmx(p)*ci(p)/forc_pbot(g)*(1._r8-c3psn(ivt(p))) 
-              psn(p) = min(wj,wc,we) 
+              wj(p) = max(ci(p)-cp,0._r8)*j/(ci(p)+2._r8*cp)*c3psn(ivt(p)) + j*(1._r8-c3psn(ivt(p)))
+              wc(p) = max(ci(p)-cp,0._r8)*vcmx(p)/(ci(p)+awc)*c3psn(ivt(p)) + vcmx(p)*(1._r8-c3psn(ivt(p)))
+              we(p) = 0.5_r8*vcmx(p)*c3psn(ivt(p)) + 4000._r8*vcmx(p)*ci(p)/forc_pbot(g)*(1._r8-c3psn(ivt(p))) 
+              psn(p) = min(wj(p),wc(p),we(p)) 
               cs = max( co2(p)-1.37_r8*rb(p)*forc_pbot(g)*psn(p), mpe )
               atmp = mp(ivt(p))*psn(p)*forc_pbot(g)*cea / (cs*ei(p)) + bp
               btmp = ( mp(ivt(p))*psn(p)*forc_pbot(g)/cs + bp ) * rb(p) - 1._r8
@@ -37607,6 +38165,11 @@
            
         end if
 
+! cmr switch vegetation back to avoid possible errors
+!        if (flop .eq. 2) then
+!         ivt(p) = temp_ivt
+!        endif
+
      end do
 
   end subroutine Stomata
@@ -37931,6 +38494,8 @@
     integer :: begg, endg   ! per-proc gridcell ending gridcell indices
     integer :: numc, nump
 !-----------------------------------------------------------------------
+    character*256 :: msg !cmr
+
     call get_proc_bounds(begg, endg, begl, endl, begc, endc, begp, endp)
 
     numc = endc-begc+1
@@ -38196,6 +38761,11 @@
     do p = begp,endp
          wtp(p)  = clm3%g%l%c%p%wtgcell(p)
     end do
+
+!cmrwrite
+   write(msg, *) 'cmr: in biophy_to_wrf: h20soi_liq = ',maxval(h2osoi_liq),'h20soi_ice = ', maxval(h2osoi_ice) &
+                 ,'h20soi_vol = ', maxval(h2osoi_vol)
+   call CLMDebug(msg)
     
   end subroutine biophy_to_wrf
 !===========================================================================================================
@@ -38701,7 +39271,8 @@
 
     found = .false.
     do c = lbc, ubc
-       if (abs(errsoi_col(c)) > 1.0e-7_r8 ) then
+       !cmr bug fix in wrf 3.5.1 if (abs(errsoi_col(c)) > 1.0e-7_r8 ) then
+       if (abs(errsoi_col(c)) > 1.0e-2_r8 ) then
           found = .true.
           indexc = c
        end if
@@ -39109,7 +39680,7 @@
 
        ! Soil evaporation resistance
        www     = (h2osoi_liq(c,1)/denh2o+h2osoi_ice(c,1)/denice)/dz(c,1)/watsat(c,1)
-       www     = min(max(www,0.0_r8),1._r8)
+       !cmr bugfix in WRF3.5.1 www     = min(max(www,0.0_r8),1._r8)
 
        !changed by K.Sakaguchi. Soilbeta is used for evaporation
        if (dqh(p) .gt. 0._r8) then   !dew  (beta is not applied, just like rsoil used to be)
@@ -57663,7 +58234,7 @@
      call var_par()
 
 
-     call CLMDebug('call surfrd')
+     call CLMDebug('call surfrd ')
      call surfrd (organicxy,efisopxy,gtixy,ilx,jlx, iveg, isl, lndmsk)
     ! Initialize clump and processor decomposition
     call CLMDebug('call initDecomp')
@@ -57920,7 +58491,8 @@
                 ,dwt_frootn_to_litr1n_buf,dwt_frootn_to_litr2n_buf, dwt_frootn_to_litr3n_buf &
                 , dwt_livecrootn_to_cwdn_buf,dwt_deadcrootn_to_cwdn_buf,retransn_buf &
 #endif         
-                                                            )
+                ,fpsn,fpsn_mn,fpsn_mx,fpsn_nf,reco,reco_gpp,reco_gppmn,reco_gppmx,atm_co2,wj,we,wc,ci_mr,rs_mr & !cmr
+                ,rb_mr,btran_mr,apar_mr,sla_mr,vcmx_mr,svpts_mr,eah_mr               )
 !-----------------------------------------------------------------------
 !
 ! !USES:
@@ -58143,7 +58715,29 @@
   real(r8)  :: sabg
   real(r8)  :: znt0
   real(r8),intent(out)  :: rhoxy
-
+  
+  real(r8)  :: fpsn !cmr
+  real(r8)  :: fpsn_mn !cmr
+  real(r8)  :: fpsn_mx !cmr
+  real(r8)  :: fpsn_nf !cmr
+  real(r8)  :: ci_mr !cmr
+  real(r8)  :: rs_mr !cmr
+  real(r8)  :: rb_mr !cmr
+  real(r8)  :: btran_mr !cmr
+  real(r8)  :: apar_mr !cmr
+  real(r8)  :: sla_mr !cmr
+  real(r8)  :: vcmx_mr !cmr
+  real(r8)  :: svpts_mr !cmr
+  real(r8)  :: eah_mr !cmr
+  real(r8)  :: reco !cmr
+  real(r8)  :: reco_gpp !cmr
+  real(r8)  :: reco_gppmn !cmr
+  real(r8)  :: reco_gppmx !cmr
+  real(r8)  :: wj !cmr
+  real(r8)  :: we !cmr
+  real(r8)  :: wc !cmr
+  real,dimension(3),intent(in)  :: atm_co2 !cmr
+  integer   :: valley_CO2pft2              ! cmr second pft with forcing of pft 1
   integer   :: nstp
 !ylu add albedo coefficients
  real(r8),dimension(1:numrad) :: cof_dir,cof_dif  !1=visible, 2=nir
@@ -58191,6 +58785,7 @@
 
 !------------------------------------------------------------------------
 
+
        call CLMDebug('Starting clm3.F')
        msg= ''
        write(msg, *) 'At i,j = ', ilx, ', ', jlx, '.'
@@ -58252,7 +58847,12 @@
     call CLMDebug('End shr_orb_params & decl')    
     call CLMDebug('Start initialize()') 
 
+
    !  write(6,*) 'in clm3, t_soisno=',t_soisno
+!cmrwrite
+!   write(msg, *) 'cmr: before initialize h20soi_liq = ', maxval(h2osoi_liq)
+!   call CLMDebug(msg)
+
     call  initialize(snl    ,snowdp  ,dzclm     ,zclm         &
                   ,ziclm       ,h2osno  ,h2osoi_liq,h2osoi_ice,t_grnd      &
                   ,t_soisno    ,t_lake  ,t_veg     ,h2ocan    ,h2ocan_col  &
@@ -58295,6 +58895,11 @@
                                                                       )
     call CLMDebug('initialize done. Back in clm3')
 
+!cmrwrite
+!   write(msg, *) 'cmr: after initialize h2osoi_liq = ', maxval(h2osoi_liq)
+!   call CLMDebug(msg)
+
+
     ! Determine necessary indices
 
     call get_proc_bounds(begg, endg, begl, endl, begc, endc, begp, endp)
